Program demo2;

uses dos,crt,graph,mycrt,graftrix,prtscrn,ADContrl,textunit,stats;

const messages: array[1..32] of string[10] =
                 ('demo2.t1','demo2.t2','demo2.t3','demo2.t4',
                  'demo2.t5','demo2.t6','demo2.t7','demo2.t8',
                  'demo2.t9','demo2.t10','demo2.t11','demo2.t12',
                  'demo2.t13','demo2.t14','demo2.t15','demo2.t16',
                  'demo2.t17','demo2.t18','demo2.t19','demo2.t20',
                  'demo2.t21','demo2.t22','demo2.t23','demo2.t24',
                  'demo2.t25','demo2.t26','demo2.t27','demo2.t28',
                  'demo2.t29','demo2.t30','demo2.t31','demo2.t32'
                  );
      mainmenuentry: array['A'..'L'] of string[60] =
           (
             'STEP A:            INTRODUCTION AND CONFIGURATION',
             'STEP B:                  MODELING THE ENVIRONMENT',
             'STEP C:          THE PERCEPTUAL OR INPUT FUNCTION',
             'STEP D:       THE COMPARATOR AND REFERENCE SIGNAL',
             'STEP E:                       THE OUTPUT FUNCTION',
             'STEP F:                 CLOSING THE FEEDBACK LOOP',
             'STEP G:             A HIGHER-LEVEL CONTROL SYSTEM',
             'STEP H:                  THE EQUATIONS OF CONTROL',
             'STEP I:              DYNAMICS: THE SLOWING FACTOR',
             'STEP J:       MATCHING THE MODEL TO REAL BEHAVIOR',
             'STEP K:                       IMPROVING THE MODEL',
             'STEP Z:                              QUIT PROGRAM'
           );

      scale = 4096;
      one80 = 2048;   {180 degrees}
      three4pi = (one80 + one80 + one80) div 4;
      rightangle = one80 div 2;
      maxmin1 = one80 - 1;
      ndata = 2047;



type   sincostype = array[-one80..maxmin1] of integer;
       distarraytype = array[0..8192] of integer;
       distptrtype =  ^distarraytype;
       dataarraytype = array[0..ndata] of integer;
       dataptrtype = ^dataarraytype;
       datatype = array[0..1799] of integer;
       randtabtype = distarraytype;
       arrowtype = (uparr,downarr,leftarr,rightarr);
       exptype = (modrun,exprun);

var  distptr: distptrtype;
     distset: set of 0..15;
     netdist: array[0..15] of
               array[0..3] of
                record
                 dpointer: dataptrtype;
                 ddiff: integer;
                 dfactor: integer;
                end;

    modhan,perhan: datatype;
    moderr,pererr: datatype;
    distmemassigned: boolean;
    distfile: file of distarraytype;

    handle,dptr,disturb,curs,perc,ref,err,qo,qi: integer;
    j,k,haspect: integer;
    textfile: text;
    sincosfile: file of sincostype;
    ch: char;
    cmd: byte;
    indicator: char;
    oldindicator: char;
    oldindx: integer;
    oldindy: integer;
    olddir: arrowtype;
    numstr: array[0..20] of string[15];
    rnumstr: array[0..20] of string[15];
    oldx: array[0..20] of integer;
    oldy: array[0..20] of integer;
    oldxr: array[0..20] of integer;
    oldyr: array[0..20] of integer;
    dist: array[0..2] of dataptrtype;
    data: array[0..3] of array[0..900] of integer;
    sine,cosine: sincostype;
    linespace: integer;
    blockimage: array[0..80] of byte;
    indicateup: array[0..200] of byte;
    indicatedown: array[0..200] of byte;
    indicateright: array[0..200] of byte;
    indicateleft: array[0..200] of byte;
    dpointer: array[0..200] of byte;
    handlex,handley,distx,disty,cursx,cursy: integer;
    gridx,gridy: integer;
    circrad: integer;
    modelnumber: integer;
    gotdata: boolean;
    kd,dkd,kf,hkf,ki,ko,slow: integer;
    kdx,kdy,dkdx,dkdy,kfx,kfy,hkfx,
    hkfy,kix,kiy,px,py,rx,ry,ex,ey,compx,compy,kox,koy,qox,qoy: integer;
    arrowkfx,arrowkfy,arrowkdx,arrowkdy,arrowkix,arrowkiy,
    arrowrefx,arrowrefy,arrowkox,arrowkoy,arrowloopx,arrowloopy: integer;
    kir,kor,kfr,kdr,rr,dr,qir,pr,er,qor,oldqor,Slowr,senseslow,rms: real;
    ADChan: integer;


{ -------------------------------------------------------------------------}

{$f+}
 procedure pltmon(x,y,color: word); external;
 procedure pltcga(x,y,color: word); external;
 procedure pltega(x,y,color: word); external;
 procedure scrmon(x,y,w,h: word); external;
 procedure scrcga(x,y,w,h: word); external;
 procedure screga(x,y,w,h: word); external;
 {$L d:\tp\obj\scrlwind.obj }
{$f-}

{ -------------------------------------------------------------------------}

procedure plot(x,y,c: integer);
begin
 case graphdriver of
  CGA,ATT400: pltcga(x,y,c);
  HercMono: pltmon(x,y,c);
  EGA,VGA: pltega(x,y,c);
 end;
end;


{ -------------------------------------------------------------------------

            CREATE FILE OF 10 DISTURBANCES, 8192 ENTRIES EACH

 -------------------------------------------------------------------------}

procedure makerand;
type smoothtype = array[0..8192] of longint;
var rand: longint;
    delta: integer;
    n: string[15];
    maxsmooth: longint;
    r0,r: longint;
    smoothavg: longint;
    smoothtab: ^smoothtype;
    outtab: ^randtabtype;
    i,j: integer;

begin
clrscr;
gotoxy(12,3); write('Main disturbance table missing: creating it');
getmem(smoothtab,sizeof(smoothtype));
getmem(outtab,sizeof(randtabtype));
assign(distfile,'maindist');
rewrite(distfile);
randomize;
for j := 0 to 9 do
begin
 gotoxy(12,12); writeln('Making random disturbance ',j);
 rand := 0;
 for i := 0 to 8191 do
 begin
  rand := rand + random(10000) - 5000 - rand div 80;
  smoothtab^[i] := rand;
 end;
 r := smoothtab^[0];
 r0 := r;
 for i := 0 to 8191 do
  begin
   r0:= r0 + (smoothtab^[i] - r0) div 60;
   r:= r + (r0 - r) div 60;
   smoothtab^[i] := r;
  end;

 smoothavg := 0;
 for i := 0 to 8191 do smoothavg := smoothavg + smoothtab^[i];
 smoothavg := smoothavg div 8192;
 for i := 0 to 8191 do smoothtab^[i] := smoothtab^[i] - smoothavg;
 maxsmooth := 0;
 for i := 0 to 8191 do
    if abs(smoothtab^[i]) > maxsmooth then maxsmooth := abs(smoothtab^[i]);

 for i := 0 to 8191 do
  begin
   r := smoothtab^[i] * 2048;
   outtab^[i] := r div maxsmooth;
  end;
 write(distfile,outtab^);
end;
close(distfile);
freemem(smoothtab,sizeof(smoothtype));
freemem(outtab,sizeof(randtabtype));
end;

{ -------------------------------------------------------------------------

        GET DISTURBANCE OF 2048 ENTRIES, WITH GIVEN DIFFICULTY,
                   INTO A TABLE POINTED TO BY "DIST", 1 ..10

 -------------------------------------------------------------------------}

procedure getdistdiff(distnum,diff: integer; dist: dataptrtype);
var dptr: distptrtype;
    i,j,delta: integer;
begin
 {$i-}
  assign(distfile,'maindist');
  reset(distfile);
 {$i+}
 if IOresult <> 0 then
  begin
   makerand;
   reset(distfile);
  end;
  getmem(dptr,sizeof(distarraytype));
 seek(distfile,distnum - 1);
 read(distfile,dptr^);
 case diff of
  0: delta := 1;
  1: delta := 2;
  2: delta := 4;
  else delta := 8;
 end;

 i := 0; j := 0;
 while j < 2048 do
  begin
   dist^[j] := dptr^[i];
   i := i + delta;
   if i > 8191 then i := i - 8192;
   inc(j);
  end;
 close(distfile);
 freemem(dptr,sizeof(distarraytype));
end;

{ -------------------------------------------------------------------------}
procedure makedpointer;
begin
 clearviewport;
 if graphdriver in [CGA,ATT400] then
  moveto(0,linespace div 2)
 else
  moveto(0,linespace div 2 - 2);
 outtext('-d');
 getimage(0,0,15,linespace,dpointer);
end;
{ -------------------------------------------------------------------------}

procedure makeindicators;
var x,y: integer;
begin
 clearviewport;
 for y := 0 to 4 do
 for x := 4-y to 4+y do
 plot(x,y,white);
 for y := 5 to 9 do
 for x :=  2 to 6 do
 plot(x,y,white);
 getimage(0,0,8,9,indicateup);

 clearviewport;
 for x := 0 to 4 do
 for y := 4-x to 4+x do
 plot(x,y,white);
 for x := 5 to 9 do
 for y :=  2 to 6 do
 plot(x,y,white);
 getimage(0,0,8,9,indicateleft);

 clearviewport;
 for y := 9 downto 5 do
 for x := 4 - (9 - y) to 4 + (9  - y) do
 plot(x,y,white);
 for y := 4 downto 0 do
 for x :=  2 to 6 do
 plot(x,y,white);
 getimage(0,0,8,9,indicatedown);

 clearviewport;
 for x := 9 downto 5 do
 for y := 4 - (9 - x) to 4 + (9 - x) do
 plot(x,y,white);
 for x := 0 to 4 do
 for y :=  2 to 6 do
 plot(x,y,white);
 getimage(0,0,8,9,indicateright);
end;


{ -------------------------------------------------------------------------}

procedure blocktext(s:string);
var i,x,y: integer;
var c: char;
begin
 x := getx; y := gety;
 c := chr(219);
 setcolor(0);
 for i := 0 to length(s) - 1 do
  outtext(chr(7));
 moveto(x,y);
 for i := 0 to length(s) - 1 do
  outtext(chr(8));
 moveto(x,y);
 setcolor(white);
 for i := 1 to length(s) do
 begin
  outtext(s[i]);
 end;
 moveto(x,y);
end;

{ -------------------------------------------------------------------------}

procedure showint(i,x,y,n: integer);
begin
 setcolor(0);
 outtextxy(oldx[i],oldy[i],numstr[i]);
 setcolor(WHITE);
 str(n:4,numstr[i]);
 outtextxy(x,y,numstr[i]);
 oldx[i] := x; oldy[i] := y;
end;

{ -------------------------------------------------------------------------}

procedure showreal(i,x,y: integer; n:real; d: integer);
var xx,yy,xw,yw: integer;
begin
 setcolor(0);
 outtextxy(oldxr[i],oldyr[i],rnumstr[i]);
 setcolor(WHITE);
 str(n:7-d:d,rnumstr[i]);
 outtextxy(x,y,rnumstr[i]);
 oldxr[i] := x; oldyr[i] := y;
end;

{ -------------------------------------------------------------------------}
function getrealgraph(i,x,y: integer; var rnum: real): byte;
var realstr: string[15];
    strptr,oldx,oldy,code: integer;
    realnum: real;
    cmd: byte;
    sign,ch: char;
begin
 oldx := getx; oldy := gety; sign := ' ';
 strptr := 0; realstr := '';
 repeat
  moveto(x,y);
  cmd := getcod;
  ch := chr(cmd);
  if (not (cmd in [Up,Down,Left,Right,EndKey,$0d])) and (not (cmd >= $80)) then
  begin
   if cmd = 08 then
    begin
     realstr := ''; strptr := 0;
    end
   else if ch in ['0'..'9','.'] then
    realstr := ch + realstr
   else if ch = '-' then sign := '-';
   moveto(x,y);
   blocktext(realstr);
  end;
 until cmd in [Up,Down,Left,Right,EndKey,$0d];
 if realstr  = '' then
  begin
   val(realstr,realnum,code);
   if code <> 0 then rnum := realnum;
  end;
  getrealgraph := cmd;
 end;

{ -------------------------------------------------------------------------}

{multiply m1 * m1, 32 bit product; divide by d to give integer result }
{ this is an assembly-language inline macro }

function dmd(m1,m2,d: integer): integer;
inline(
   $59/$5b/$58/      { pop cx, pop ax, pop bx }
   $f7/$eb/          { imul bx }
   $f7/$f9);         { idiv cx }

{ -------------------------------------------------------------------------}

procedure linedraw(dataptr: dataptrtype; y,scale: integer);
var i,j,k,yy,y0,oldj,oldy,ps: integer;
begin
 moveto(0,y - dmd(dataptr^[0],vcenter,scale));
 for i := 1 to 900 do
 if i mod 3 = 0 then
 begin
  j := i div 3;
  yy := dmd(dataptr^[i],vcenter,scale);
  lineto(j,y - yy);
 end;
end;

{ -------------------------------------------------------------------------}

procedure showtext(s: string);
var textstr: string[80];
begin
 assign(textfile,s);
 {$i-}
 reset(textfile);
 {$i+}
 clrscr;
 if IOResult <> 0 then
  begin
   gotoxy(12,12); write('MESSAGE FILE ',s,' NOT FOUND: SEE DOCUMENTS');
   delay(5000); halt;
  end
 else
  while not eof(textfile) do
   begin
    readln(textfile,textstr);
    if wherey < 25 then writeln(textstr)
    else write(textstr);
   end;
 close(textfile);
end;

{ -------------------------------------------------------------------------}

procedure showgraphtext(s: string);
var textstr: string[80];
    ln,i: integer;
begin
 ln := 1;
 assign(textfile,s);
 {$i-}
 reset(textfile);
 {$i+}
 if IOResult <> 0 then
  begin
   restorecrtmode;
   closegraph;
   gotoxy(12,12); write('MESSAGE FILE ',s,' NOT FOUND: SEE DOCUMENTS');
   delay(5000); halt;
  end
 else
  while not eof(textfile) do
   begin
    readln(textfile,textstr);
    outtextxy(0,linespace * ln,textstr);
    inc(ln);
   end;
 close(textfile);
end;

{ -------------------------------------------------------------------------}

procedure initreals;
begin
 rr := 0.0; dr := 0.0; Kfr := 1.0; Kdr := 1.0;
 qor := 0.0; oldqor := 0.0; qir := 0.0; er := 0.0; dr := 0.0;
 Kir := 1.0; Kor := 50.0; Slowr := 51.0;
end;

{ -------------------------------------------------------------------------}

procedure solveslow(cc: char);
var x,y,u,v: integer;
begin
 x := wherex; y := wherey;
 qor := oldqor + (Kor * er - oldqor)/Slowr;
 if Qor > 1E4 then Qor := 1E4
 else
 if Qor < -1E4 then Qor := -1E4;
 v := 15;
 gotoxy(1,v); blanks(8); write(qor:8:2);
 gotoxy(12,v); blanks(8); write(oldqor:8:2);
 gotoxy(23,v); blanks(8); write(Kor:8:2);
 gotoxy(32,v); blanks(8); write(er:8:2);
 gotoxy(43,v); blanks(8); write(oldqor:8:2);
 gotoxy(57,v); blanks(8); write(slowr:8:2);
 oldqor := qor;
 gotoxy(x,y);
end;

{ -------------------------------------------------------------------------}
procedure showliveslowline(i: integer; cc: char);
begin
 gotoxy(71,i+4);
 case i of
  0: write(Kor:8:2);
  1: write(er:8:2);
  2: write(Slowr:8:2);
 end;
end;

{ -------------------------------------------------------------------------}

procedure liveslowing(cc: char);
var x,y,i: integer;
    realnum: real;
    done: boolean;
begin
 textbox(65,3,79,13);
 done := false; oldqor := 0.0; Slowr := 2.0;
 for i := 0 to 2 do showliveslowline(i,cc);
 i := 0;
 cmd := $0d;
 if Slowr <= 0.01 then Slowr := 0.01;
 repeat
  if cmd = $0d then solveslow(cc);
  textattr := $70;
  showliveslowline(i,cc);
  case i of
   0: realnum := Kor;
   1: realnum := er;
   2: realnum := Slowr;
  end;
  cmd := getrealstr(realnum,7);
  realnum := abs(realnum);
  case i of
   0: Kor := realnum;
   1: er := realnum;
   2: Slowr := realnum;
  end;
  if Slowr <= 0.01 then Slowr := 0.01;
  textattr := $0f;
  showliveslowline(i,cc);
  case cmd of
   Up: if i > 0 then dec(i) else i := 2;
   Down: if i < 2 then inc(i) else i := 0;
  end;
  done := cmd = EndKey;
 until done;
end;

{ -------------------------------------------------------------------------}

procedure solveit(cc: char);
var x,y,u,v: integer;
begin
 x := wherex; y := wherey;
 qir := Kfr * qor + Kdr * dr;
 pr := qir * Kir;
 er := rr - pr;
 if cc < 'I' then
  qor := qor + (Kor * er - qor)/(1 + abs(Kir*Kor*Kfr))
 else
  qor := oldqor + (Kor * er - oldqor)/Slowr;
 if qor > 1e4 then qor := 1e4 else
 if qor < -1e4 then qor := -1e4;
 v := 12;
 gotoxy(1,v); blanks(8); write(qir:8:2);
 gotoxy(12,v); blanks(8); write(Kfr:8:2);
 gotoxy(24,v); blanks(8); write(qor:8:2);
 gotoxy(40,v); blanks(8); write(Kdr:8:2);
 gotoxy(53,v); blanks(8); write(dr:8:2);
 v := 15;
 gotoxy(1,v); blanks(8); write(pr:8:2);
 gotoxy(12,v); blanks(8); write(Kir:8:2);
 gotoxy(24,v); blanks(8); write(qir:8:2);
 v := 18;
 gotoxy(1,v); blanks(8); write(er:8:2);
 gotoxy(12,v); blanks(8); write(rr:8:2);
 gotoxy(24,v); blanks(8); write(pr:8:2);
 v := 21;
 if cc < 'I' then
  begin
   gotoxy(1,v); blanks(8); write(qor:8:2);
   gotoxy(12,v); blanks(8); write(Kor:8:2);
   gotoxy(24,v); blanks(8); write(er:8:2);
  end
 else
  begin
   gotoxy(1,v); blanks(8); write(qor:8:2);
   gotoxy(12,v); blanks(8); write(oldqor:8:2);
   gotoxy(23,v); blanks(8); write(Kor:8:2);
   gotoxy(32,v); blanks(8); write(er:8:2);
   gotoxy(43,v); blanks(8); write(oldqor:8:2);
   gotoxy(57,v); blanks(8); write(slowr:8:2);
  end;
 oldqor := qor;
 gotoxy(x,y);
end;

{ -------------------------------------------------------------------------}
procedure showliveline(i: integer; cc: char);
begin
 if cc < 'I' then gotoxy(69,i+3)
 else gotoxy(70,i+3);
 case i of
  0: write(rr:8:2);
  1: write(dr:8:2);
  2: write(kfr:8:2);
  3: write(kdr:8:2);
  4: write(kir:8:2);
  5: write(kor:8:2);
  6: if cc = 'I' then write(Slowr:8:2);
 end;
end;

{ -------------------------------------------------------------------------}

procedure liveequations(cc: char);
var x,y,i: integer;
    m,realnum: real;
    done: boolean;
begin
 Slowr := 1.0 + kir * kor * kfr;
 textbox(62,2,79,15);
 done := false;
 for i := 0 to 6 do showliveline(i,cc);
 i := 0;
 textattr := $70;
 solveit(cc);
 repeat
  textattr := $0f;
  if cc = 'I' then
   begin
    m := kir * kor * kfr;
    gotoxy(70,16); blanks(8); write(m:8:2);
    gotoxy(70,18); blanks(8); write(1.0 + m:8:2);
    if Slowr < 0.001 then Slowr := 0.001;
   end;
  textattr := $70;
  showliveline(i,cc);
  if cc < 'I' then
  while not keypressed do solveit(cc)
  else if cmd = $0d then solveit(cc);
  case i of
   0: realnum := rr;
   1: realnum := dr;
   2: realnum := Kfr;
   3: realnum := Kdr;
   4: realnum := Kir;
   5: realnum := Kor;
   6: realnum := Slowr;
  end;
  cmd := getrealstr(realnum,8);
  case i of
   0: rr := realnum;
   1: dr := realnum;
   2: Kfr := abs(realnum);
   3: Kdr := abs(realnum);
   4: Kir := abs(realnum);
   5: Kor := realnum;
   6: if abs(slowr) >= 1.0 then Slowr := abs(realnum);
  end;
  textattr := $0f;
  showliveline(i,cc);

  case cmd of
   Up: if i > 0 then dec(i) else i := 6;
   Down: if i < 6 then inc(i) else i := 0;
  end;
  if cc < 'I' then if i = 6 then i := 0;
  done := cmd = EndKey;
 until done;
end;

{ -------------------------------------------------------------------------}

procedure makesincos;
var i,j,k: integer;
    u,v: real;
begin
 clrscr; writeln; writeln(
'     Trigonometric table not found: creating SINCOS');
 for i := -one80 to one80 - 1 do
 begin
  u := scale * cos(i * pi/one80);
  v := scale * sin(i * pi/one80);
  cosine[i] := round(u);
  sine[i] := round(v);
 end;
end;

{ ---------------------------------------------------------------------------}

procedure getsincos;
begin
 assign(sincosfile,'sincos');
 {$i-}
 reset(sincosfile);
 {$i+}
 if IOResult <> 0 then
  begin
   makesincos;
   rewrite(sincosfile);
   write(sincosfile,sine,cosine);
   close(sincosfile);
  end
 else
  begin
   read(sincosfile,sine,cosine);
   close(sincosfile);
  end;
end;

{ -------------------------------------------------------------------------}

procedure showindicator(x,y: integer; dir: arrowtype);
var i: integer;
begin
 for i := 0 to 1 do
  begin
   if oldindx <> -1 then
   case olddir of
       uparr: putimage(oldindx - 4,oldindy + 1,indicateup,XORPut);
     leftarr: putimage(oldindx + 1,oldindy - 4,indicateleft,XORPut);
     downarr: putimage(oldindx - 4,oldindy - 10,indicatedown,XORPut);
    rightarr: putimage(oldindx - 10,oldindy - 4,indicateright,XORPut);
   end;
   oldindx := x; oldindy := y; olddir := dir;
  end;
end;

{ -------------------------------------------------------------------------}

procedure runexp(usemod: exptype; cv: integer);
var i,k: integer;
    model: boolean;
    cursreal: real;
begin
 model := usemod = modrun;
 if not model then
  case cv of
   0:  showgraphtext(messages[22]);
   1:  showgraphtext(messages[23]);
   2:  showtext(messages[24]);
  end;
 if not model then
  case cv of
   0: begin plotbar(vcenter,9); plotbar(vcenter,11); end;
   1: sound(300);
   2: begin gotoxy(12,12); write('Maintain at 50'); end;
  end;
 if not model then
 while not keypressed do
  begin
   handle := dmd(ADread(ADChan),vcenter,1479);
   ADstart(ADChan);
   if cv = 0 then plotbar(vcenter - curs,10);
   disturb := dmd(dist[0]^[180],vcenter,2048);
   curs := handle + disturb;
   retrace; retrace;
  end;
 if not model then ch := readkey;
 qo := 0; qor := 0.0; cursreal := 0.0;
 for k := -180 to 1799 do
 begin
  i := abs(k);
  if model then handle := qo
   else handle := dmd(ADread(ADChan),vcenter,1479);
  ADstart(ADChan);
  if model then modhan[i] := handle else perhan[i] := handle;
  disturb := dmd(dist[0]^[i],vcenter,2048);
  curs := handle + disturb;
  if model then
   begin
    if modelnumber = 0 then
      cursreal := curs
    else
     cursreal := cursreal + (curs - cursreal) / senseslow;
    er := rr - cursreal;
    qor := qor + (kor*er - qor) / slowr;
    qo := round(qor);
   end
  else
   begin
    retrace; retrace;
    case cv of
     0: plotbar(vcenter - curs,10);
     1: sound(300 + curs);
     2: begin gotoxy(39,12); write(50 + curs div 5:3); end;
    end;
   end;
 end;
 if cv = 1 then nosound;
end;

{ -------------------------------------------------------------------------}

procedure showdata(kind: exptype; color: integer);
var x,y,i,j,hh,dd,cc: integer;
    plotoffset,diff: integer;
begin
 if kind = modrun then
   plotoffset := (vsize + vsize + vsize ) div 4
 else plotoffset := vsize div 4;
 rms := 0.0;
 for i := 0 to 355 do
 begin
  j := i + i + i + i + i;
  if kind = modrun then hh := modhan[i] else hh := perhan[i];
  plot(i,plotoffset - hh div 2,color);
  plot(i,plotoffset - hh div 2 + 1,color);
  disturb := dmd(dist[0]^[i],vcenter,2048);
  curs := hh + disturb;
  plot(i,plotoffset - disturb div 2,color);
  plot(i,plotoffset - curs div 2,color);
  plot(i,plotoffset,color);
  if kind = modrun then
   begin
    diff := perhan[i] - modhan[i];
    if diff < 180 then
    rms := rms + diff * diff
    else rms := rms + 32767.0;
    plot(i,vsize div 2 - diff div 2,color);
    plot(i,vsize div 2,color);
   end;
 end;
 rms := sqrt(rms/356.0);
end;

{ -------------------------------------------------------------------------}

procedure showconstline(l,cv: integer);
var v: real;
begin
 case l of
  0: v := Kor;
  1: v := Slowr;
  2: case cv of
      0: v := rr;
      1: v := rr + 300.0;
      2: v := rr/5.0 + 50.0;
     end;
  3: v := senseslow;
 end;
 showreal(l,538,(l+1)*vsize div 11,v,2);
end;

{ -------------------------------------------------------------------------}

procedure showconstants(cv: integer);
var i: integer;
begin
 outtextxy(0,linespace,'PERSON DATA           HEAVY TRACE IS HANDLE');
 outtextxy(0,vsize - 1,'MODEL DATA');
 outtextxy(0,vsize div 2 - linespace,'DIFFERENCE');
 outtextxy(370,vsize div 11,    'Output const.  Ko =');
 outtextxy(370,2 * vsize div 11,'Slowing factor S  =');
 outtextxy(370,3 * vsize div 11,'Ref signal     r  =');
 case cv of
  1: outtextxy(370,3 * vsize div 11 + 9,'Original tone     =  300 Hz');
  2: outtextxy(370,3 * vsize div 11 + 9,'Nominal target    =  50');
 end;
 if modelnumber > 0 then
  outtextxy(370,4* vsize div 11,'Sensory slowing   =');
 outtextxy(370,vsize div 2,'Pers - Model RMS  =');
 outtextxy(370,vsize div 2 - linespace,'Ko/S, Int factor  =');
 outtextxy(370,vsize div 2 + linespace,'Pers:Model, corr  =');
 rectangle(367,5*vsize div 8 - linespace - 1,
           370 + textwidth('Left/Right to decrease/increase'),
           5 * vsize div 8 + 41);
 outtextxy(370,5 * vsize div 8,     '    Up/down arrow to select,');
 outtextxy(370,5 * vsize div 8 + 10,'Left/Right to decrease/increase');
 outtextxy(370,5 * vsize div 8 + 20,'    Enter Key for model run');
 outtextxy(370,5 * vsize div 8 + 30,'  "c" or "C" for correlation');
 outtextxy(370,5 * vsize div 8 + 40,'     End Key for Main Menu');
 outtextxy(370,vsize -22, 'Disturbance numb  =');
 outtextxy(370,vsize -11, 'Difficulty factor =');
 outtextxy(370,vsize - 1, 'Controlled var.   =');
end;


{ -------------------------------------------------------------------------}

procedure matchmodel(maxi: integer);
const di: integer = 2;
      dd: integer = 2;
      cv: integer = 0;

var cmd: byte;
    i,oldi: integer;
    more: boolean;
    deltas,deltak: real;
    ch: char;
begin
repeat
 if maxi = 3 then modelnumber := 1 else modelnumber := 0;
 cv := 0;
 if gotdata then
 begin
  clrscr; gotoxy(12,12);
  write('Stored run data exists. Use it?  Y/N: ');
  ch := readkey;
  gotdata := ch in ['y','Y'];
 end;
 if not gotdata then
 begin
  repeat
   clrscr; gotoxy(12,12); clreol; write('Pick disturbance, 1..10: ');
   readln(di);
  until di in [1..10];
  repeat
   gotoxy(12,14); clreol; write('Degree of difficulty, 0..3: ');
   readln(dd);
  until dd in [0..3];
  getdistdiff(di,dd,dist[0]);
  repeat
   gotoxy(12,16); clreol;
   write('Control cursor (1), Sound (2), or Number (3): ');
   readln(cv);
  until cv in [1..3];
  cv := cv - 1;
 end;
 if cv <> 2 then begin setgraphmode(graphmode); clearviewport; end;
 if not gotdata then runexp(exprun,cv);
 if cv = 2 then setgraphmode(graphmode);
 gotdata := true;
 clearviewport;
 settextjustify(LeftText,BottomText);
 showconstants(cv);
 showint(8,538,vsize - 22,di);
 showint(9,538,vsize - 11,dd);
 case cv of
  0: outtextxy(538,vsize - 1,' Bar');
  1: outtextxy(538,vsize - 1,'Tone');
  2: outtextxy(538,vsize - 1,'Numb');
 end;
 for i := 0 to maxi do showconstline(i,cv);
 oldindx := -1;
 showdata(exprun,white);
 i := 0; cmd := $0d;
 repeat
  if cmd = $0d then
  begin
   showdata(modrun,0);
   runexp(modrun,cv);
   showdata(modrun,white);
   showreal(4,538,vsize div 2,rms,3);
   showreal(5,538,vsize div 2 - linespace,Kor/Slowr,3);
  end;
  showindicator(368,(i + 1) * vsize div 11 - 4,rightarr);
  cmd := getcod;
  repeat
   deltak := 0.02 * Kor;
   deltas := 0.02 * Slowr;
   case cmd of
    Up: if i > 0 then dec(i) else i := maxi;
    Down: if i < maxi then inc(i) else i := 0;
    Left,Right: case i of
                0: if cmd = Right then Kor := Kor + deltak
                   else Kor := Kor - deltak;
                1: if cmd = Right then Slowr := Slowr + deltas
                   else
                    if slowr > Kor/1.9 + deltas then slowr := slowr - deltas;
                2: if cmd = Right then rr := rr + 1.0 else rr := rr - 1.0;
                3: if Cmd = Right then Senseslow := Senseslow + 0.5
                    else if senseslow >= 1.5 then senseslow := senseslow - 0.5;
               end;
    ord('p'): prtscr;
   end;
   showreal(5,538,vsize div 2 - linespace,Kor/Slowr,3);
   if chr(cmd) in ['c','C'] then
    begin
     correl('i',@perhan[0],@modhan[0],1800);
     showreal(6,538,vsize div 2 + linespace,corr,4);
     sound(1200); delay(50); nosound;
    end;
   if cmd in [Left,Right] then showconstline(i,cv);
   if cmd in [Up,Down] then showindicator(368,i * vsize div 11 - 4,rightarr);
   more := keypressed;
   if more then cmd := getcod;
  until not more;
 until cmd = EndKey;
 restorecrtmode;
 clrscr; gotoxy(12,12); write('Repeat with new disturbance? Y/N: ');
 ch := readkey;
 gotdata := not (ch in ['y','Y']);
until not (ch in ['y','Y']);
end;

{ -------------------------------------------------------------------------}

procedure markdata(y,handfact: integer; target: boolean);
var maxh,maxd,maxhj,maxdj,hy,j,h,t,d,c: integer;
begin
 maxh := 0; maxd := 0;
 for j := 0 to 900 do
 if j mod 3 = 0 then
 begin
  h := dmd(data[0][j],2,3);
  if abs(h) > maxh then
   begin
    maxh := abs(h);
    maxhj := j;
   end;
  d := dmd(dmd(dist[0]^[j],vcenter,2048),2,3);
  if target then
   t := dmd(dmd(dist[1]^[j],vcenter,2048),2,3)
  else t := 0;
  if abs(d - t) > maxd then
   begin
    maxd := abs(d - t);
    maxdj := j;
   end;
  c := dmd(h,handfact,100) + d - t;
 end;
 if maxhj > maxdj then j := maxhj else j := maxdj;
 hy := dmd(data[0][j],2,3);
 moveto(j div 3,y - hy);
 lineto(j div 3 + 10,y - hy - 6);
 moverel(3,4); blocktext('Handle');

 d := dmd(dist[0]^[j],vcenter,2048);
 if target then
   t := dmd(dist[1]^[j],vcenter,2048)
 else t := 0;
 c := dmd(dmd(data[0][j],handfact,100) + d - t,2,3);
 moveto(j div 3,y - c);
 if c > 0 then
   lineto(j div 3 + 10,y - c - 12)
 else
   lineto(j div 3 + 10,y - c + 12);
 moverel(3,4);
 if target then blocktext('Cur-Tar')
 else blocktext('C.Var');
 d := dmd(dist[0]^[j],vcenter,2048);
 if target then
   t := dmd(dist[1]^[j],vcenter,2048)
 else t := 0;
 d := dmd(d - t,2,3);
 moveto(j div 3,y - d);
 lineto(j div 3 + 10,y - d - 6);
 moverel(3,4);
 if target then
  blocktext('D1-D2')
 else blocktext('Disturbance');
 moveto(310,y + 4); outtext('TIME -->');
end;

{ -------------------------------------------------------------------------}
procedure plotdata(y,handfact: integer; target: boolean);
var j,h,d,t,c: integer;
begin
  for j := 0 to 900 do
  if j mod 3 = 0 then
  begin
   h := dmd(data[0][j],2,3);
   d := dmd(dmd(dist[0]^[j],vcenter,2048),2,3);
   if target then
    begin
     t := dmd(dmd(dist[1]^[j],vcenter,2048),2,3);
     d := d - t;
    end
   else t := 0;
   c := dmd(h,handfact,100) + d;
   plot(j div 3,y - h,white);
   plot(j div 3,y - h - 1,white);
   plot(j div 3,y - h + 1,white);
   plot(j div 3,y - c,white);
   plot(j div 3,y - d,white);
   plot(j div 3,y,white);
  end;
end;

{ -------------------------------------------------------------------------}

procedure comptrack;
var n,i,j,k,y,maxh,maxhj,maxd,maxdj,hy,h,d,c: integer;
    corr: real;
    numstr: string[8];
begin
repeat
 repeat
  clrscr; showtext(messages[7]);
  gotoxy(68,17);
  readln(n);
 until n in [1..10];
 getdistdiff(n,0,dist[0]);
 setgraphmode(graphmode);
 clearviewport;
 showgraphtext(messages[8]);
 j := 0;
 plotbar(vcenter,13); plotbar(vcenter,15);
 while not keypressed do
  begin
    c := dmd(ADread(ADChan) + dist[0]^[120],vcenter,2048);
    ADstart(ADChan);
    retrace;
    plotbar(vcenter - c,14);
  end;
  ch := readkey;
  for k := -120 to 900 do
   begin
    j := abs(k);
    h := dmd(ADread(ADChan),vcenter,2048);
    ADstart(ADChan);
    data[0][j] := h;
    d := dmd(dist[0]^[j],vcenter,2048);
    c := h + d;
    retrace;
    plotbar(vcenter - c,14);
   end;
  sound(800); delay(500); nosound;
  y := vcenter + vcenter div 3;
  clearviewport;
  plotdata(y,100,false); markdata(y,100,false);
  outtextxy(360,vsize - 10,'"r" to repeat, space to quit');
  showgraphtext(messages[9]);
  for i := 0 to 900 do
    data[3][i] := data[0][i] + dmd(dist[0]^[i],vcenter,2048);
  correl('i',@data[0],@data[3],900);
  moveto(68,5 * linespace);
  str(corr:5:3,numstr);
  outtext(numstr);
  moveto(432,6 * linespace);
  correl('i',@data[0],dist[0],900);
  str(corr:5:3,numstr);
  outtext(numstr);
  ch := readkey;
  restorecrtmode;
 until ch <> 'r';
end;


{ -------------------------------------------------------------------------}

procedure indicate(n: char);
begin
 case n of
  'A': showindicator(arrowkdx,arrowkdy,downarr);
  'B': showindicator(arrowkfx,arrowkfy,downarr);
  'C': showindicator(arrowkix,arrowkiy,leftarr);
  'D','G': showindicator(arrowrefx,arrowrefy,leftarr);
  'E': showindicator(arrowkox,arrowkoy,leftarr);
  'F': showindicator(arrowloopx,arrowloopy,rightarr);
 end;
end;

{ -------------------------------------------------------------------------}

procedure changevar(n: char; c: char);
begin
 case n of
  'A': begin
      if (kd < 300) and (c = '+') then kd := (kd + 10)
      else
      if (kd > 0) and (c = '-') then kd := kd - 10;
      showreal(1,kdx,kdy,kd/100.0,2);
     end;
  'B': begin
      if (kf < 300) and (c = '+') then kf := (kf + 10)
      else
      if (kf > 0) and (c = '-') then kf := kf - 10;
      showreal(2,kfx,kfy,kf/100.0,2);
     end;
  'C': begin
      if (ki < 300) and (c = '+') then ki := (ki + 10)
      else
      if (ki > 0) and (c = '-') then ki := ki - 10;
      showreal(3,kix,kiy,ki/100.0,2);
     end;
  'D','G': begin
      if (ref < 100) and (c = '+') then ref := (ref + 10)
      else
      if (ref > -100) and (c = '-') then ref := ref - 10;
      showint(6,rx,ry,ref);
     end;
  'E','F': begin
      if (ko < 5000) and (c = '+') then ko := (ko + 25)
      else
      if (ko > 25) and (c = '-') then ko := ko - 25;
      showreal(4,kox,koy,ko/100.0,2);
     end;
 end;
end;

{ -------------------------------------------------------------------------}

procedure arrow(dir: arrowtype);
var x0,y0: integer;
begin
 x0 := getx; y0 := gety;
 case dir of
  uparr: begin
          lineto(getx - 4,gety + 3);
          moveto(x0,y0);
          lineto(getx + 4,gety + 3);
         end;
  downarr: begin
          lineto(getx - 4,gety - 3);
          moveto(x0,y0);
          lineto(getx + 4,gety - 3);
         end;
  rightarr: begin
          lineto(getx - 4,gety - 3);
          moveto(x0,y0);
          lineto(getx - 4,gety + 3);
         end;
  leftarr: begin
          lineto(getx + 4,gety - 3);
          moveto(x0,y0);
          lineto(getx + 4,gety + 3);
         end;
 end;
 moveto(x0,y0);
end;

{ -------------------------------------------------------------------------}

procedure boxleft(w,h: integer);
var x,y0,dh: integer;
begin
 y0 := gety; x := getx; dh := h div 2;
 rectangle(x - w,y0 - dh,x,y0 + dh);
 moveto(x - w,y0);
end;

{ -------------------------------------------------------------------------}

procedure boxright(w,h: integer);
var y0,x,dh: integer;
begin
 y0 := gety; x := getx; dh := h div 2;
 rectangle(x,y0 - dh,x + w,y0 + dh);
 moveto(x + w,y0);
end;

{ -------------------------------------------------------------------------}

procedure boxup(w,h: integer);
var x0,y,dw: integer;
begin
 x0 := getx; y := gety; dw := w div 2;
 rectangle(x0 - dw,y - h,x0 + dw,y);
 moveto(x0,y - h);
end;

{ -------------------------------------------------------------------------}

procedure boxdown(w,h: integer);
var x0,y,dw: integer;
begin
 x0 := getx; y := gety; dw := w div 2;
 rectangle(x0 - dw,y,x0 + dw,y + h);
 moveto(x0,y + h);
end;

{ -------------------------------------------------------------------------}

procedure envdiagram(i: char);
var hx,hy,tx,ty,outy: integer;
    j,k,u,v: integer;
    y2: integer;
begin
 settextjustify(LeftText,CenterText);
 setcolor(white);
 if i < 'H' then
 begin
  outtextxy(hsize - 100,vcenter - linespace,'keep cursor');
  outtextxy(hsize - 100,vcenter,'<-- here');
 end;
 if i = 'H' then
  setviewport(3 * gridx + gridx div 2,0,hsize - 1,vsize - 1,false);
 circrad := gridy div 2;
 hx := 7 * gridx; hy := 19 * gridy;
 k := hy - linespace - linespace div 2;
 if i > 'B' then
   for j := 0 to 8 * ((hx + 8) div 8) do
    if ((j shr 3) and 1) > 0 then plot(j,k,white);
 circle(hx,hy,circrad);
 handlex := hx; handley := hy;
 if i < 'H' then
  moveto(handlex - 66,handley + linespace div 2 + 2)
 else
  moveto(handlex - 16,handley + linespace div 2 + 2);
 if (i < 'C') then outtext('h: ')
 else begin
       outtext('q'); moverel(0,2); outtext('o');
       moverel(0,-2);  if i < 'H' then outtext(':');
      end;
 moveto(hx-circrad,hy); lineto(5 * gridx,hy); arrow(leftarr);
 boxleft(2 * gridx, gridy + 2);
 tx := getx; ty := gety;
 moverel(gridx,-gridy div 2 - 1);arrowkfx := getx; arrowkfy := gety;
 moveto(tx,ty);
 moverel(-48,-linespace div 2 - 2);
 if i < 'C' then outtext('h*K') else
  begin
   outtext('q'); moverel(0,2); outtext('o');moverel(0,-2);
   outtext('*K');
  end;
 moverel(0,2); outtext('f');
 moveto(tx,ty);
 moverel(-24,- 2 * linespace);
 if i < 'C' then
  begin
   outtext('c = h * K');
   moverel(0,2);outtext('f');
   moverel(0,-2);
   outtext('  +  d * K');
   moverel(0,2); outtext('d');
  end;
 moveto(tx,ty);
 moverel(-56,linespace div 2 + 2); hkfx := getx; hkfy := gety;
 moveto(tx,ty);
 if i < 'H' then moverel(3,0) else moverel(gridx - 4,0);
 outtext('K'); moverel(0,2); outtext('f');
 moverel(0,-2); kfx := getx + 16; kfy := gety;
 moveto(tx,ty);
 lineto(gridx + circrad,hy); arrow(leftarr);
 circle(gridx,gety,circrad);
 cursx := 0; cursy := hy + linespace div 2;
 moveto(cursx,cursy - 2);
 if(i < 'C') then outtext(' c:')
 else
  begin
   outtext('q'); moverel(0,2); outtext('i');
   moverel(0,-2); if i < 'H' then outtext(':');
  end;
 moveto(gridx,gety + circrad); arrow(uparr);
 lineto(getx,22*gridy); lineto(3 * gridx,gety);
 tx := getx; ty := gety;
 moverel(-48,-linespace div 2 - 2); outtext('d*K'); moverel(0,2); outtext('d');
 moveto(tx,ty);
 moverel(gridx,- gridy div 2 - 1);arrowkdx := getx; arrowkdy := gety;
 moveto(tx,ty);
 moverel(-56,linespace div 2 + 2); dkdx := getx; dkdy := gety;
 moveto(tx,ty);
 if i < 'H' then moverel(3,0) else moverel(gridx - 4,0);
 outtext('K'); moverel(0,2); outtext('d');
 moverel(0,-2); kdx := getx + 16; kdy := gety;
 moveto(tx,ty);
 boxright(2*gridx,gridy + 2); arrow(leftarr);
 lineto(7*gridx - circrad,gety);
 circle(7 * gridx,gety,circrad);
 distx := 7 * gridx; disty := 22 * gridy;
 if i < 'H' then
  outtextxy(distx - 66,disty + linespace div 2 + 2,'d: ')
 else
  outtextxy(distx - 16,disty + linespace div 2 + 2,'d');

 if i < 'C' then exit;

 moveto(gridx,hy - circrad);
 lineto(gridx,16 * gridy + linespace div 2 + 2);
 arrow(uparr); boxup(2 * gridx,gridy + 2);
 outy := gety;
 tx := getx; ty := gety;
 moveto(getx - gridx + 3,gety + linespace div 2 + 1);
 if i >= 'H' then moverel(gridx - 8,0);
 outtext('K'); moverel(0,2); outtext('i');
 moverel(0,-1); kix := getx + 16; kiy := gety;
 arrowkix := 2 * gridx + 2; arrowkiy := kiy;
 moveto(tx,ty);
 lineto(gridx,14 * gridy);
 tx := getx; ty := gety;
 px := 0; py := gety + linespace - 2;
 if i < 'H' then outtextxy(px,py - linespace - 2,' p:')
 else
  outtextxy(px,py - linespace - 2,' p');
 moveto(tx,ty); lineto(3*gridx,gety); arrow(rightarr);

 if i < 'D' then exit;

 tx := getx; ty := gety;
 moveto(tx+6,ty); outtext('Comparator');
 moveto(tx,ty);
 boxright(2*gridx,gridy + 2);
 tx := getx; ty := gety;
 moveto(4*gridx,gety - gridy div 2 - 2);
 arrow(downarr); lineto(getx,gety - 2 * gridy);
 moveto(getx - 24,gety);
 if i < 'H' then outtext('r:') else outtext('r');
 rx := getx - 32; ry := gety + linespace + 2;
 arrowrefx := 4 * gridx + 2; arrowrefy := ry;
 moveto(tx,ty); lineto(hx,ty);
 tx := getx; ty := gety;
 moveto(5 * gridx + 2,ty - 4);
 if i < 'H' then outtext('  e:') else outtext('  e');
 ex := getx - 30; ey := gety + linespace + 2;

if i < 'E' then exit;

 moveto(tx,ty);
 lineto(getx,outy);
 arrow(downarr);
 boxdown(2 * gridx,gridy + 2);
 arrowkox := getx + gridx + 2; arrowkoy := gety - linespace div 2 - 2;
 tx := getx; ty := gety;
 moveto(getx - gridx + 2,gety - linespace div 2 - 1);
 if i >= 'H' then moverel(gridx - 8,0);
 outtext('K'); moverel(0,2); outtext('o'); moverel(0,-1);
 kox := getx + 16; koy := gety;
 moveto(tx,ty);
 if i <> 'H' then
  begin
   lineto(tx,ty + linespace);
   moveto(getx + 26,gety);
   outtext('q'); moverel(0,2); outtext('o'); moverel(0,-2);
  end
 else
  begin
   lineto(hx,hy - circrad);
   arrow(downarr);
  end;
 qox := getx + 12; qoy := gety;
 if i = 'H' then
  setviewport(0,0,hsize - 1,vsize - 1,false);

 if (i < 'F') or (i = 'H') then exit;

 arrowloopx := 6 * gridx + gridx div 2;
 arrowloopy := qoy + linespace div 2;

end;

{ -------------------------------------------------------------------------}

procedure movehandle(x0,y0,angle: integer);
const oldx: integer = 0;
      oldy: integer = 0;
      oldsx: integer = 0;
      oldsy: integer = 0;
var sx,sy,len: integer;
begin
 if angle > 1600 then angle := 1600
 else if angle < -1600 then angle := -1600;
 len := gridy + gridy div 2;
 moveto(oldsx,oldsy); setcolor(0); lineto(oldx,oldy);
 setcolor(white);
 oldsx := x0 + dmd(circrad + 1,cosine[angle],haspect);
 oldsy := y0 + dmd(circrad + 1,sine[angle],4096);
 oldx := x0 + dmd(len,cosine[angle],haspect);
 oldy := y0 + dmd(len,sine[angle],4096);
 moveto(oldsx,oldsy);
 lineto(oldx,oldy);
end;

{ -------------------------------------------------------------------------}

procedure showdiag(maxindicator: char);
var i,j,u,v,messnum,blink: integer;
    blinkon: boolean;
    tempqo: real;
    loop,running: boolean;
    ch: char;
    cmd: byte;

procedure pickmessnum(ind: char);
begin
 case ind of
  'A': messnum := 3;
  'B': messnum := 4;
  'C': messnum := 6;
  'D': messnum := 8;
  'E': messnum := 10;
  'F': messnum := 12;
  'G': messnum := 14;
  else messnum := -1;
 end;
end;

begin
 oldindx := -1; oldindy := -1; blink := 0; blinkon := true;
 ki := 100; kd := 100; kf := 100; ko := 100; ref := 0;
 if maxindicator = 'E' then begin kf := 0; ko := 300; end;
 loop := false;
 running := true;
 outtextxy(1, vsize - linespace div 2 - 1,
'Pick constant: Up/Dn;  Inc/Dec: Rt/Lft/+/-;  Pause/Cont: Space;  Quit: "q/Q"');
 outtextxy(8 * gridx, 23 * gridy + 2,'h,d vs time');
 indicator := maxindicator;
 oldindicator := indicator;
 indicate(indicator);
 pickmessnum(indicator);
 showgraphtext(messages[messnum]);
 dptr := 0; ch := chr(0); qo := 0;
 disturb := maxint;
 if maxindicator = 'G' then
  begin ko := 5000; loop := true; end;
 plotbar(vcenter,10); plotbar(vcenter,12);
 showreal(1,kdx,kdy,kd/100.0,2);
 showreal(2,kfx,kfy,kf/100.0,2);
 if maxindicator > 'B' then showreal(3,kix,kiy,ki/100.0,2);
 if maxindicator > 'D' then showreal(4,kox,koy,ko/100.0,2);
 moveto(arrowloopx - 52, arrowloopy + 1);
 if maxindicator = 'F' then blocktext('OPEN') else blocktext('LOOP');
 tempqo := 0.0;
 repeat
  retrace;
  if loop then handle := qo
  else if running then handle := dmd(ADread(ADChan),vcenter,1479);
  ADstart(ADChan);
  hkf := dmd(handle,kf,100);
  movehandle(handlex,handley,-dmd(handle,1011,vcenter));
  u := 10 * gridx - 4; v := 21 * gridy;
  if disturb <> maxint then
   putimage((u and $fff8) + 2,v - disturb div 10 - 5,dpointer,XorPut);
  if running then disturb := dmd(dist[0]^[dptr],vcenter,2048);
  putimage((u and $fff8) + 2,v - disturb div 10 - 5,dpointer,XorPut);
  dkd := dmd(disturb,kd,100);
  if running then inc(dptr);
  if dptr > 2047 then dptr := 0;
  curs := hkf + dkd;
  perc := dmd(ki,curs,100);
  err := ref - perc;
  if err > 400 then err := 400 else
  if err < -400 then err := -400;
  tempqo := tempqo + (0.01 * ko * err - tempqo)/(1.0 + 1E-6 * kf * ki * ko);
  qo := round(tempqo);
  showint(0,0,cursy + linespace,curs);
  if curs < -vcenter + 20 then curs := -vcenter + 20
  else if curs > vcenter - 2 then curs := vcenter - 2;
  plotbar(vcenter - curs,11);
  showint(1,distx - 42,disty + linespace div 2 + 2,disturb);
  showint(2,handlex - 42,handley + linespace div 2 + 2,handle);
  showint(3,dkdx,dkdy,dkd);
  showint(4,hkfx,hkfy,hkf);
  if maxindicator > 'B' then showint(5,px,py,perc);
  if maxindicator > 'C' then
   begin
    showint(6,rx,ry,ref);
    showint(7,ex,ey,err);
   end;
  if maxindicator > 'D' then showint(8,qox,qoy,qo);
  if running and (dptr mod 5 = 0) then
  begin
   case graphdriver of
    CGA,ATT400: scrcga(u shr 3 - gridx shr 2,v - 2 * gridy,
                       gridx shr 2,4 * gridy - 2);
    EGA,VGA   : screga(u shr 3 - gridx shr 2,v - 2 * gridy,
                       gridx shr 2,4 * gridy - 2);
    HercMono  : scrmon(u shr 3 - gridx shr 2,v - 2 * gridy,
                       gridx shr 2,4 * gridy - 2);
   end;
   plot((u and $fff8) - 1, v - disturb div 10 - 2,white);
   plot((u and $fff8) - 1, v - 2,white);
   plot((u and $fff8) - 1, v - handle div 10 - 2,white);
  end;
  while keypressed do
   begin
    cmd := getcod;
    ch := chr(cmd);
    if ch = ' ' then running := not running;
    if not (ch in ['q','Q']) then
     begin
      case cmd of
       F1: if maxindicator < 'F' then loop := false
           else
            begin
             loop := not loop;
             moveto(arrowloopx - 52, arrowloopy + 1);
             if not loop then blocktext('OPEN')
             else blocktext('LOOP');
             if loop then
              begin
               tempqo := 0.0;
               qo := 0;
              end;
            end;
       ord('p'): prtscr;
       ord('+'),right: changevar(indicator,'+');
       ord('-'),left:  changevar(indicator,'-');
       up: if indicator < maxindicator then inc(indicator)
           else indicator := 'A';
       down: begin
              dec(indicator);
              if indicator < 'A' then indicator := maxindicator;
             end;
      end;
     indicate(indicator);
     if indicator <> oldindicator then
      for i := 0 to 1 do
       begin
        if i = 0 then setcolor(0) else setcolor(white);
        pickmessnum(oldindicator);
        if messnum > -1 then
         showgraphtext(messages[messnum]);
        oldindicator := indicator;
       end;
     end;
   end;
 until (ch in ['q','Q']);
end;

{ -------------------------------------------------------------------------}

procedure showmenuline(i: char);
begin
 gotoxy(15,6 + ord(i) - ord('A')); write(mainmenuentry[i]);
end;

{ -------------------------------------------------------------------------}

procedure showmainmenu;
var i: char;
begin
 clrscr;
 gotoxy(1,1); write(
'  I N T R O D U C T I O N   T O   C O N T R O L   T H E O R Y ,  P A R T   2');
 gotoxy(1,2); write(
     '                   Modeling compensatory tracking');
textattr := $70;
 gotoxy(1,3); write(
'        Use Up/Down arrow keys & select with "Enter", or type letter');
textattr := $0f;
for i := 'A' to 'L' do showmenuline(i);
end;


{ -------------------------------------------------------------------------}

procedure mainmenu;
var cmd: byte;
    i: char;
begin
 clrscr; showmainmenu;
 for cmd := 0 to 20 do
  begin
   rnumstr[cmd] := ' '; oldxr[cmd] := 0; oldyr[cmd] := 0
  end;
 i := 'A';
 repeat
  mousex^ := 0; mousey^ := 0;
  textattr := $70;
  showmenuline(i);
  cmd := getcod;
  textattr := $0f;
  oldindx := -1;
  showmenuline(i);
  case cmd of
   Up: if i > 'A' then dec(i) else i := 'L';
   Down: if i < 'L' then inc(i) else i := 'A';
  end;
  if chr(cmd) in ['A'..'Z','a'..'z'] then
   begin i := chr(cmd and $df); cmd := $0d; end;
  if cmd = $0d then
  begin
   case i of
    'A': begin showtext(messages[1]); ch := readkey; end;
    'B'..'G': begin
          case i of
           'B': showtext(messages[2]);
           'C': showtext(messages[5]);
           'D': showtext(messages[7]);
           'E': showtext(messages[9]);
           'F': showtext(messages[11]);
           'G': showtext(messages[13]);
          end;
          ch := readkey;
          setgraphmode(graphmode);
          clearviewport;
          envdiagram(i);
          showdiag(i);
          restorecrtmode;
         end;
      'H': begin
            showtext(messages[15]);
            ch := readkey;
            setgraphmode(graphmode);
            clearviewport;
            initreals;
            envdiagram('H');
            showgraphtext(messages[16]);
            ch := readkey;
            restorecrtmode;
            showtext(messages[17]);
            initreals;
            liveequations('H');
           end;
      'I': begin
            showtext(messages[18]);
            ch := readkey;
            showtext(messages[19]);
            initreals;
            liveslowing('I');
            clrscr;
            showtext(messages[20]);
            initreals;
            liveequations('I');
           end;
      'J': begin
            showtext(messages[21]);
            ch := readkey;
            kor := 200.0; slowr := 1000.0; rr := 0.0; senseslow := 1.0;
            matchmodel(2);
            cmd := 1;
           end;
      'K': begin
            showtext(messages[25]);
            ch := readkey;
            matchmodel(3);
            cmd := 1;
           end;

    'L'..'Z': cmd := EndKey;
   end;
   if cmd <> EndKey then
   begin
    if i < 'L' then inc(i) else i := 'A';
    clrscr; showmainmenu;
   end;
  end;
 until cmd = EndKey;
end;

{ -------------------------------------------------------------------------}
{ -------------------------------------------------------------------------}


begin
 clrscr;
 writeln('Note: This program uses channel 1');
 ADChan := 1;
 usekbd := false;
 if not SetAtoD then halt;
 selectgraph(0,DETECT);
 setcolor(white);
 makeindicators;
 indicator := 'A'; oldindicator := 'A';
 haspect := round(vsize / 15.0 * 22.5 / hsize * 4096.0);
 settextjustify(LeftText,CenterText);
 linespace := vsize div 25;
 clearviewport;
 getimage(0,0,linespace,8,blockimage);
 gridx := hsize div 16;
 gridy := linespace;
 makedpointer;
 restorecrtmode;
 textattr := white;
 writeln('loading functions');
 getsincos;
 writeln('reserving memory for disturbances');
 getmem(dist[0],sizeof(dataarraytype));
 writeln('memory reserved');
 getdistdiff(3,0,dist[0]);
 kd := 100; kf := 100; ki := 100; ko := 100; ref := 0;
 kor := 400.0; Slowr := 4500.0; senseslow := 1.0; rr := 0.0;
 gotdata := false;
 mainmenu;
 freemem(dist[0],sizeof(dataarraytype));
 closegraph;
 clrscr;
end.